#include "bindio.h"
#include <iostream>

OutputStream* XiOutputStream::impl()
{
    if (!initialized)
        static_cast<XiOutputStream_vtable*>(vptr)->__classOp(CallCtor, this);
    return getImpl();
}

void XiOutputStream::invokeDtor(void* mePtr, void*)
{
    XiOutputStream* me = static_cast<XiOutputStream*>(mePtr);
    if (me->initialized)
        me->vtable()->__classOp(CallDtor, me);
}

void XiOutputStream::__classOp(ClassOp op, void* memory)
{
    XiOutputStream* me = static_cast<XiOutputStream*>(memory);
    if (op == CallCtor) {
        new (memory) XiOutputStream();
        me->createImpl();
    } else {
        me->~XiOutputStream();
    }
}

XiOutputStream::XiOutputStream()
{
    if (!vptr)
        vptr = &XI(_vt_OutputStream);
}

XiOutputStream::XiOutputStream(FILE *f) {
    file = f;
    if (!vptr)
        vptr = &XI(_vt_OutputStream);
}
void XiOutputStream::puts(XiOutputStream* __thisPtr, void* s)
{
    XiOutputStream* __this = static_cast<XiOutputStream*>(__thisPtr);
    // XXX should do UCS-4 -> UTF-8 conversion here.
    int64_t *s_ = (int64_t *)s;
    for (int64_t i = 0; i < s_[-1]; i++)
        fputc(s_[i], __this->file);
}

void XiOutputStream::putc(XiOutputStream* __thisPtr, int64_t c)
{
    XiOutputStream* __this = static_cast<XiOutputStream*>(__thisPtr);
    fputc(c, __this->file);
}

void XiOutputStream::flush(XiOutputStream* __thisPtr)
{
    XiOutputStream* __this = static_cast<XiOutputStream*>(__thisPtr);
    fflush(__this->file);
}

XiOutputStream_vtable XI(_vt_OutputStream);
int64_t XI(_size_OutputStream);
void XI(_init_OutputStream)()
{
    if (XI(_size_OutputStream)) return;
    XI(_size_OutputStream) = sizeof(XiOutputStream);
    XI(_vt_OutputStream).puts = XiOutputStream::puts;
    XI(_vt_OutputStream).putc = XiOutputStream::putc;
    XI(_vt_OutputStream).flush = XiOutputStream::flush;
    XI(_vt_OutputStream).__classOp = XiOutputStream::__classOp;
}

InputStream* XiInputStream::impl()
{
    if (!initialized)
        static_cast<XiInputStream_vtable*>(vptr)->__classOp(CallCtor, this);
    return getImpl();
}

void XiInputStream::invokeDtor(void* mePtr, void*)
{
    XiInputStream* me = static_cast<XiInputStream*>(mePtr);
    if (me->initialized)
        me->vtable()->__classOp(CallDtor, me);
}

void XiInputStream::__classOp(ClassOp op, void* memory)
{
    XiInputStream* me = static_cast<XiInputStream*>(memory);
    if (op == CallCtor) {
        new (memory) XiInputStream();
        me->createImpl();
    } else {
        me->~XiInputStream();
    }
}

XiInputStream::XiInputStream()
{
    if (!vptr)
        vptr = &XI(_vt_InputStream);
}

int64_t XiInputStream::bufGetC() {
	if (hasBufferedChar) {
		hasBufferedChar = false;
		return bufferedChar;
	}
	return fgetc(file);
}

int64_t* XiInputStream::gets(XiInputStream* __thisPtr)
{
    XiInputStream* __this = static_cast<XiInputStream*>(__thisPtr);
    int64_t bufSize = 160; // not counting space for \0
    int64_t *buf     = str_alloc(bufSize);
    int64_t bufPos = 0;
    int64_t code;

    // XXX Should do UTF-8 -> UCS-4 conversion here
    while (!endsLine(code = __this->bufGetC())) {
        buf[bufPos] = code;
        bufPos++;
        if (bufPos >= bufSize) {
			bufSize *= 2;
			buf = str_realloc(buf, bufSize);
        }
    }
    // Truncate to actual length
    if (bufPos != bufSize)
        buf = str_realloc(buf, bufPos);

    return buf;
}

int64_t XiInputStream::getc(XiInputStream* __thisPtr)
{
    XiInputStream* __this = static_cast<XiInputStream*>(__thisPtr);
    return __this->bufGetC();
}

int64_t XiInputStream::feof(XiInputStream* __thisPtr)
{
    XiInputStream* __this = static_cast<XiInputStream*>(__thisPtr);
    if (!__this->hasBufferedChar) {
        __this->bufferedChar = fgetc(__this->file);
        __this->hasBufferedChar = true;
    }

    return __this->bufferedChar == EOF ? 1 : 0;
}

XiInputStream_vtable XI(_vt_InputStream);
int64_t XI(_size_InputStream);
void XI(_init_InputStream)()
{
    if (XI(_size_InputStream)) return;
    XI(_size_InputStream) = sizeof(XiInputStream);
    XI(_vt_InputStream).gets = XiInputStream::gets;
    XI(_vt_InputStream).getc = XiInputStream::getc;
    XI(_vt_InputStream).feof = XiInputStream::feof;
    XI(_vt_InputStream).__classOp = XiInputStream::__classOp;
}

FileInput* XiFileInput::impl()
{
    if (!initialized)
        static_cast<XiFileInput_vtable*>(vptr)->__classOp(CallCtor, this);
    return getImpl();
}

void XiFileInput::invokeDtor(void* mePtr, void*)
{
    XiFileInput* me = static_cast<XiFileInput*>(mePtr);
    if (me->initialized)
        me->vtable()->__classOp(CallDtor, me);
}

void XiFileInput::__classOp(ClassOp op, void* memory)
{
    XiFileInput* me = static_cast<XiFileInput*>(memory);
    if (op == CallCtor) {
        new (memory) XiFileInput();
        me->createImpl();
    } else {
        me->~XiFileInput();
    }
}

XiFileInput::XiFileInput()
{
    if (vptr == &XI(_vt_InputStream))
        vptr = &XI(_vt_FileInput);
}

XiInputStream::XiInputStream(FILE *f) {
	file = f;
    if (vptr == &XI(_vt_InputStream))
        vptr = &XI(_vt_FileInput);
}


void XiFileInput::close(XiFileInput* __thisPtr)
{
    XiFileInput* __this = static_cast<XiFileInput*>(__thisPtr);
    fclose(__this->file); 
}

XiFileInput_vtable XI(_vt_FileInput);
int64_t XI(_size_FileInput);
void XI(_init_FileInput)()
{
    if (XI(_size_FileInput)) return;
    XI(_init_InputStream)();
    XI(_size_FileInput) = sizeof(XiFileInput);
    XI(_vt_FileInput).close = XiFileInput::close;
    XI(_vt_FileInput).gets = XiFileInput::gets;
    XI(_vt_FileInput).getc = XiFileInput::getc;
    XI(_vt_FileInput).feof = XiFileInput::feof;
    XI(_vt_FileInput).__classOp = XiFileInput::__classOp;
}

FileOutput* XiFileOutput::impl()
{
    if (!initialized)
        static_cast<XiFileOutput_vtable*>(vptr)->__classOp(CallCtor, this);
    return getImpl();
}

void XiFileOutput::invokeDtor(void* mePtr, void*)
{
    XiFileOutput* me = static_cast<XiFileOutput*>(mePtr);
    if (me->initialized)
        me->vtable()->__classOp(CallDtor, me);
}

void XiFileOutput::__classOp(ClassOp op, void* memory)
{
    XiFileOutput* me = static_cast<XiFileOutput*>(memory);
    if (op == CallCtor) {
        new (memory) XiFileOutput();
        me->createImpl();
    } else {
        me->~XiFileOutput();
    }
}

XiFileOutput::XiFileOutput()
{
    if (vptr == &XI(_vt_OutputStream))
        vptr = &XI(_vt_FileOutput);
}

void XiFileOutput::close(XiFileOutput* __thisPtr)
{
    XiFileOutput* __this = static_cast<XiFileOutput*>(__thisPtr);
    fclose(__this->file); 
}

XiFileOutput_vtable XI(_vt_FileOutput);
int64_t XI(_size_FileOutput);
void XI(_init_FileOutput)()
{
    if (XI(_size_FileOutput)) return;
    XI(_init_OutputStream)();
    XI(_size_FileOutput) = sizeof(XiFileOutput);
    XI(_vt_FileOutput).close = XiFileOutput::close;
    XI(_vt_FileOutput).puts = XiFileOutput::puts;
    XI(_vt_FileOutput).putc = XiFileOutput::putc;
    XI(_vt_FileOutput).flush = XiFileOutput::flush;
    XI(_vt_FileOutput).__classOp = XiFileOutput::__classOp;
}

XiFileInput* XI(readFile_o9FileInputai)(void* filename)
{
    int64_t *filename_ = (int64_t *)filename;
    XiFileInput *fi = gcNew<XiFileInput>();
    fi->file = fopen(str_toC(filename_), "r");
    return fi->file ? fi : 0;
}

XiFileOutput* XI(createFile_o10FileOutputai)(void* filename)
{
    int64_t *filename_ = (int64_t *)filename;
    XiFileOutput *fo = gcNew<XiFileOutput>();
    fo->file = fopen(str_toC(filename_), "wx");
    return fo->file ? fo: 0;
}

XiFileOutput* XI(appendFile_o10FileOutputai)(void* filename)
{
    int64_t *filename_ = (int64_t *)filename;
    XiFileOutput *fo = gcNew<XiFileOutput>();
    fo->file = fopen(str_toC(filename_), "a");
    return fo->file ? fo : 0;
}

bool XI(removeFile_bai)(void* filename)
{
    int64_t *filename_ = (int64_t *)filename;
    int64_t result = remove(str_toC(filename_));
    return (result == 0) ? true : false;
}

static XiOutputStream *_out = new XiOutputStream(stdout);
static XiInputStream *_in = new XiInputStream(stdin);

XiOutputStream *XI(stdout_o12OutputStream)() {
	return _out;
}

XiInputStream *XI(stdin_o11InputStream)() {
	return _in;
}
