/**
 Some exports to help write Xi bindings
*/
#ifndef LIBXI_H
#define LIBXI_H

#ifdef __cplusplus
#define XI_EXPORT extern "C"
#else
#define XI_EXPORT
#endif

#if !defined(__CYGWIN__) && !defined(__APPLE__) && !defined(__MINGW32__)
#define XI(x) _I ## x
#else
#define XI(x) I ## x
/* On Cygwin/Windows (and apparently OS X) the compiler adds _ itself to
   everything; so we don't need one of our own */
#endif

#include <stdint.h>

// Main allocation hook
XI_EXPORT int64_t* XI(_alloc_i)(int64_t size);

// Registers a finalizer for a given object
typedef void Finalizer(void*, void*);
XI_EXPORT void xi_registerFinalizer(void* object, Finalizer* fin);


#endif
// kate: indent-width 4; replace-tabs on; tab-width 4; space-indent on;
