#ifndef Xi_OBJ_H
#define Xi_OBJ_H

#include <new>

#include "libxi.h"

struct XiVTable {
};

struct XiObj {
    XiObj(): initialized(true)
    {}

    XiVTable* vptr;

    // This field is set to false when we are merely allocated
    // via GC, such as when an Xi subclass allocates our memory;
    // and true when we've actually called a constructor.
    bool initialized;
};

template<typename T> T* gcNew() {
    T* t = reinterpret_cast<T*>(XI(_alloc_i)(sizeof(T)));
    new (t) T;
    xi_registerFinalizer(t, T::invokeDtor);
    return t;
}

// Like gcNew, but doesn't deal with constructors or destructors
template<typename T> T* gcCalloc() {
    return reinterpret_cast<T*>(XI(_alloc_i)(sizeof(T)));
}

inline int64_t toXI(int64_t v) {
    return v;
}

inline bool toXI(bool v) {
    return v;
}

inline int64_t fromXI(int64_t v) {
    return v;
}

inline bool fromXI(bool v) {
    return v;
}

inline void* fromXI(void* v) {
    return v;
}

enum ClassOp {
    CallCtor, // also responsible for calling createImpl
    CallDtor
};

struct DummyPeer
{};

#endif

// kate: indent-width 4; replace-tabs on; tab-width 4; space-indent on; hl c++;
